#include "udmsearch.h"

#ifdef CHARSET
#include "charset.h"

static
unsigned char _12512koi[] = {
	0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8b,0x8c,0x8d,0x8e,0x8f,
	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,
	0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8, 'C',0xaa,0xab,0xac,0xad, 'R',0xaf,
	0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8, 'N',0xba,0xbb,0xbc,0xbd,0xbe,0xbf,
	
	0xe1,0xe2,0xf7,0xe7,0xe4,0xe5,0xf6,0xfa,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,0xf0,
	0xf2,0xf3,0xf4,0xf5,0xe6,0xe8,0xe3,0xfe,0xfb,0xfd,0xff,0xf9,0xf8,0xfc,0xe0,0xf1,
	0xC1,0xC2,0xD7,0xC7,0xC4,0xC5,0xD6,0xDA,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,
	0xD2,0xD3,0xD4,0xD5,0xC6,0xC8,0xC3,0xDE,0xDB,0xDD,0xDF,0xD9,0xD8,0xDC,0xC0,0xD1

		};
static
unsigned char _koi21251[] = { 
	0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8b,0x8c,0x8d,0x8e,0x8f,
	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,
	0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,
	0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,

	0xfE,0xe0,0xe1,0xf6,0xE4,0xe5,0xf4,0xE3,0xf5,0xE8,0xe9,0xea,0xeb,0xec,0xed,0xee,
	0xeF,0xff,0xf0,0xf1,0xf2,0xf3,0xe6,0xe2,0xfC,0xfB,0xe7,0xf8,0xfD,0xf9,0xf7,0xfA,
	0xdE,0xc0,0xc1,0xd6,0xc4,0xc5,0xd4,0xc3,0xd5,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,
	0xcF,0xdf,0xd0,0xd1,0xd2,0xd3,0xc6,0xc2,0xdC,0xdB,0xc7,0xd8,0xdD,0xd9,0xd7,0xdA
		};


//------------------------------------------------------------------------------
unsigned char *win2koi(unsigned char *is)
{
int i=-1;
unsigned int c=0;
     while  (is[++i]) {
     	c=is[i];
	if ( c > 0x7F ) {
		is[i]=_12512koi[is[i]-0x80] ;
	};
     }
return is;
}
//------------------------------------------------------------------------------
unsigned char *koi2win(unsigned char *is)
{
int i=-1;
unsigned int c=0;
     while  (is[++i]!=0) {
//     	printf("Reading char : %c \n",is[i]);
        c=is[i];
	if( c > 0x7F ) {
		is[i]=_koi21251[c & 0x7f] ;
	};
    }
return is;
}
//------------------------------------------------------------------------------
unsigned char *_1251_to_koiN(unsigned char *is,int n)
{
 int i=-1;
 unsigned int c=0;
     while  (++i<n) {
//printf("I=%d, C=%d , is[i]= %d\n",i,c,is[i]);
        c=is[i];
	if( c > 0x7F ) {
		is[i]=_12512koi[is[i]-0x80] ;
//printf("-----------is[i]= %d\n",is[i]);
	};
    }
return is;
}
//------------------------------------------------------------------------------
unsigned char *koi_to_1251N( unsigned char *is,int n)
{
int i=-1;
unsigned int c=0;
     while  (++i<n) {
        c=is[i]; 
	if( c > 0x7F ) {
		is[i]=_koi21251[is[i]-0x80] ;
	};
     }
return is;
}



char rus_lower_letters[]="";
char rus_upper_letters[]="";
char rus_tolower(char c)
{
int i;
	for(i=0;i<strlen(rus_lower_letters);i++)
		if(c==rus_upper_letters[i])
			return(rus_lower_letters[i]);
	return(tolower(c));
}


#endif
