#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "search.h"
#include "mysql.h"

#include "udmsearch.h"

#ifdef CHARSET
#include "charset.h"
#endif

#define MODE_ALL  1
#define MODE_ANY  2
#define SEPARATOR " \t\r\n\\\" []^_!#$%&'()*+,-./:;<=>?@^_`{|}~"

MYSQL mysql;
char *MySQLHost       = MYSQL_HOST;
char *MySQLDB         = MYSQL_DB;
char *MySQLUser       = MYSQL_USER;
char *MySQLPass       = MYSQL_PASS;
MYSQL_RES *res;
MYSQL_ROW row;

void abort_search()
{
	printf("Indexer: Error #%d (%s)\n",mysql_errno(&mysql),mysql_error(&mysql));
	exit(-1);
}

int PrintForm(char *query,int mode)
{
printf("
<FORM METHOD=GET ACTION=\"search.cgi\">
<TABLE BORDER=\"0\" WIDTH=\"100%%\" BGCOLOR=\"#EEEEEE\">
<TR><TD>
<CENTER>
<TABLE BORDER=\"1\" BGCOLOR=\"#EEEEEE\">
<TR>
<TD>
<TABLE BGCOLOR=\"#EEEEEE\" WIDTH=\"100%%\" BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\">
<TR>
<TD BGCOLOR=\"#AAAAAA\">
<FONT COLOR=\"#FFFFFF\">Search:</FONT><INPUT TYPE=\"hidden\" NAME=\"np\" VALUE=\"0\">
</TD>
</TR>
<TR>
<TD>
<INPUT TYPE=\"TEXT\" NAME=\"q\" SIZE=\"30\" VALUE=\"%s\">
<INPUT TYPE=\"SUBMIT\" VALUE=\"Search!\">
</TD>
</TR>
<TR>
<TD BGCOLOR=\"#AAAAAA\">
<SELECT NAME=\"m\">
<OPTION VALUE=\"any\"%s>Any of the words</OPTION>
<OPTION VALUE=\"all\"%s>All of the words</OPTION>
</SELECT>
</TD>
</TR>
</TABLE>
</TD>
</TR>
</TABLE>
</CENTER>
</TD></TR>
</TABLE>
</FORM>
",query?query:"",mode==MODE_ANY?" selected":"",mode==MODE_ALL?" selected":"");
}

int Unescape(char *dest,char *src){
char *s,*d;
int hi,lo=0;
	if(!dest||!src)return(1);
	s=src;d=dest;
	while(*s){
		if(*s=='%'){
			if(strchr("0123456789",*(s+1))) hi=*(s+1)-'0';
			else hi=*(s+1)-'A'+10;
			if(strchr("0123456789",*(s+2))) lo=*(s+2)-'0';
			else lo=*(s+2)-'A'+10;
			*d=hi*16+lo; s+=3; d++;
		}else
		if(*s=='+'){
			*d=' '; s++; d++;
		}else{
			*d=*s; s++; d++;
		}
	}
	*d=0;
}

int EscapeForm(char *dest,char *src){
char *s,*d;
int hi,lo=0;
 	if(!dest||!src)return(1);
	s=src;d=dest;
	while(*s){
		if(*s=='"'){
			strcpy(d,"&quot;"); s++;d+=6;
		}else{
			*d=*s; s++; d++;
		}
	}
	*d=0;
}

int EscapeUrl(char *dest,char *src){
char *s,*d;
int hi,lo=0;
 	if(!dest||!src)return(1);
	s=src;d=dest;
	while(*s){
		if(*s==' '){
			*d='+'; s++;d++;
		}else{
			*d=*s; s++; d++;
		}
	}
	*d=0;
}

main(int argc, char **argv) {
char WORDIN[BUFSIZ]="";
char URLIN[BUFSIZ]="";
char Q[BUFSIZ]="";
char Q1[BUFSIZ]="";
char qbuf[BUFSIZ]="";
char *env,*s,*t,*q=NULL,*f=NULL,*sq=NULL;
int mode=MODE_ANY;
int ps=20;
int np=0;
int rows,i,found;
int is_next=0;
int nwords=0;

	printf("Content-type: text/html\r\n\r\n");
	
	printf("<HTML>\n");
	printf("<HEAD>\n");
	printf("<TITLE>UdmSearch result</TITLE>\n");
	printf("</HEAD>\n");
	printf("<BODY BGCOLOR=\"#FFFFFF\">\n");

	env=getenv("QUERY_STRING");
	if(env){
		s=strtok(env,"&");
		while(s){
			if(!strncmp(s,"q=",2)){
				q=(char*)malloc(strlen(s)*4);
				f=(char*)malloc(strlen(s)*4);
				Unescape(q,s+2);
				EscapeForm(f,q);
			}
			if(!strncmp(s,"np=",3)){
				np=atoi(s+3);
			}
			if(!strncmp(s,"m=",2)){
				if(!strncmp(s+2,"any",3))
					mode=MODE_ANY;
				else
					mode=MODE_ALL;
			}
			s=strtok(NULL,"&");
		}
	}
	PrintForm(f,mode);
	if(q){
		sq=(char*)malloc(strlen(q)*4);
		EscapeUrl(sq,q);
		s=strtok(q,SEPARATOR);
		while(s){
			nwords++;
			t=s;
			while(*t){
#ifdef CHARSET
				*t=rus_tolower(*t);
#else
				*t=tolower(*t);
#endif;
				t++;
			}
			if(!*WORDIN){
				sprintf(WORDIN,"'%s'",s);
				sprintf(Q,"sum((word='%s')",s);
			}else{
				strcat(WORDIN,",'");
				strcat(WORDIN,s);
				strcat(WORDIN,"'");
				strcat(Q,"+");
				strcat(Q,"(word='");
				strcat(Q,s);
				strcat(Q,"')");
			}
			s=strtok(NULL,SEPARATOR);
		}
		strcat(Q,")");
	}
	if(!*WORDIN){
		printf("</BODY></HTML>\n");
		exit(0);
	}

	if (!(mysql_connect(&mysql,MySQLHost,MySQLUser,MySQLPass)))abort_search();
	if (mysql_select_db(&mysql,MySQLDB))abort_search();
	
	printf("<HR><TABLE BORDER=\"0\" WIDTH=\"100%%\" BGCOLOR=\"#EEEEEE\" CELLPADDING=10><TR><TD><small>\n");
	
	sprintf(qbuf,"SELECT word,count(*) as c FROM dict WHERE word IN (%s) GROUP BY word ORDER BY word",WORDIN);
	if(mysql_query(&mysql,qbuf))abort_search();
	if(res=mysql_store_result(&mysql)){
		rows=mysql_num_rows(res);
		for(i=0;i<rows;i++){
			row=mysql_fetch_row(res);
			printf("%s: %s",row[0],row[1]);
			if(i+1<rows)printf(", ");
			else printf("  &nbsp; &nbsp; ");
		}
		mysql_free_result(res);
	}
	sprintf(qbuf,"SELECT word FROM stopword WHERE word IN (%s) ORDER BY word",WORDIN);
	if(mysql_query(&mysql,qbuf))abort_search();
	if(res=mysql_store_result(&mysql)){
		rows=mysql_num_rows(res);
		for(i=0;i<rows;i++){
			nwords--;
			row=mysql_fetch_row(res);
			printf("%s: stop-word",row[0]);
			if(i+1<rows)printf(", ");
		}
		mysql_free_result(res);
	}
	printf("</small> &nbsp; </TD></TR></TABLE><HR>\n");

	if(mode==MODE_ANY)
		nwords=0;
	sprintf(qbuf,"SELECT count(*)as c,dict.url_id FROM url,dict WHERE url.rec_id=dict.url_id AND word IN (%s) GROUP BY dict.url_id HAVING c>=%d",WORDIN,nwords);
	if(mysql_query(&mysql,qbuf))abort_search();
	if(res=mysql_store_result(&mysql)){
		found=mysql_num_rows(res);
		mysql_free_result(res);
	}

	if(found==0){
		printf("<center>Sorry, no documents found.</center></BODY></HTML>\n");
		exit(0);
	}

	sprintf(qbuf,"SELECT url.rec_id,%s AS q,sum(intag) AS q1,count(*) as c FROM url,dict WHERE url.rec_id=dict.url_id AND word IN (%s) GROUP BY 1 HAVING c>=%d ORDER BY q DESC,q1 DESC LIMIT %d,%d",Q,WORDIN,mode==MODE_ANY?0:nwords,np*ps,ps+1);
	strcpy(URLIN,"");
	if(mysql_query(&mysql,qbuf))abort_search();
	if(res=mysql_store_result(&mysql)){
		rows=mysql_num_rows(res);
		for(i=0;i<rows;i++){
			row=mysql_fetch_row(res);
			is_next=(rows==(ps+1));
			if(i==0) sprintf(URLIN,"%s",row[0]);
			else
			if(i<ps){
				strcat(URLIN,",");
				strcat(URLIN,row[0]);
			}
		}
		mysql_free_result(res);
	}
	
	printf("Documents %d-%d from %d found<BR><BR>\n",np*ps+1,np*ps+(rows<ps?rows:ps),found);
	sprintf(qbuf,"SELECT %s AS q,url.url,url.title,url.text,url.content_type,url.last_modified,url.size,sum(intag) AS q1 FROM url,dict WHERE url.rec_id=dict.url_id AND url.rec_id IN (%s) AND dict.word IN (%s) GROUP BY url.url ORDER BY q DESC,q1 DESC",Q,URLIN,WORDIN);

	if(mysql_query(&mysql,qbuf))abort_search();
	if(res=mysql_store_result(&mysql)){
		rows=mysql_num_rows(res);
		for(i=0;i<rows;i++){
			row=mysql_fetch_row(res);
			printf("\n\n<DT>\n\n %d) <a href=\"%s\" target=\"new\"><B>%s</B></a>[%s]\n<DD>\n   <small>\n%s\n    <BR>\n<DD>\n    <a href=\"%s\" target=\"new\"><B>%s</B></a> (%s) %s Size:%s bytes\n   <P>\n   </small>\n\n",
			np*ps+1+i,row[1],*row[2]?row[2]:"No title",row[0],row[3],row[1],row[1],row[4],row[5],row[6]);
		}
		mysql_free_result(res);
	}
	
	printf("<HR><TABLE BGCOLOR=\"#EEEEEE\" BORDER=\"0\" WIDTH=\"100%%\"><TR><TD><CENTER> &nbsp; \n");
	
	if(np>0){
		printf("<a href=\"search.cgi?np=%d&q=%s&m=%s\">Prev %d</a> &nbsp; ",np-1,sq,mode==MODE_ALL?"all":"any",ps);
	}
	if(is_next){
		printf("<a href=\"search.cgi?np=%d&q=%s&m=%s\">Next %d</a>",np+1,sq,mode==MODE_ALL?"all":"any",ps);
	}
	printf("</center></TD></TR></TABLE><HR>\n");


	printf("<TABLE WIDTH=\"100%%\" BORDER=0><TR>\n");
	printf("<TD WIDTH=\"30%%\" ALIGN=LEFT>%s</TD>\n",WEB_ORG);
	printf("<TD WIDTH=\"30%%\" ALIGN=CENTER><a href=\"http://search.udm.net/about/\"><img src=\"%s\"></a></TD>\n",WEB_LOGO);
	printf("<TD WIDTH=\"30%%\" ALIGN=RIGHT><a href=\"mailto:%s\">%s</a></TD>\n",WEB_ADMIN,WEB_ADMIN);
	printf("</TR></TABLE>\n");
	printf("</BODY></HTML>\n");
}
